menufuncs =
{
	main =
	{
		enter = 
			function(parent,name)
				local x = tilesize * 5
				local y = roomsize * tilesize * 0.5 + tilesize * 2
				
				local vers = MF_getversion()
				
				local disable = MF_gdc()
				
				writetext("version: " .. vers,0,tilesize * 0.5,tilesize * 0.75,name,false,2)
				
				createbutton("start",x,y,2,8,1,"start the game",name,3,2,"MainMenuButton")
				
				y = y + tilesize
				
				createbutton("custom",x,y,2,8,1,"custom levels",name,3,2,"MainMenuButton",disable)
				
				y = y + tilesize
				
				createbutton("editor",x,y,2,8,1,"level editor",name,3,2,"MainMenuButton",false)
				
				y = y + tilesize
				
				createbutton("settings",x,y,2,8,1,"settings",name,3,2,"MainMenuButton")
				
				y = y + tilesize
				
				createbutton("credits",x,y,2,8,1,"credits",name,3,2,"MainMenuButton",disable)
				
				y = y + tilesize
				
				createbutton("quit",x,y,2,8,1,"exit the game",name,3,2,"MainMenuButton")
			end,
		leave = 
			function(parent,name)
				MF_delete("MainMenuButton")
			end,
		submenu_leave =
			function(parent,name)
				MF_visible("MainMenuButton",0)
			end,
		submenu_return =
			function(parent,name)
				MF_visible("MainMenuButton",1)
			end,
	},
	settings =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = 3 * tilesize
				
				local disable = MF_gdc()
				
				writetext("settings",0,x,y,name,true,2)
				
				x = roomsize * tilesize * 0.5 - tilesize * 1
				y = y + tilesize * 2
				
				writetext("music volume:",0,x - tilesize * 6,y,name,false,2)
				local mvolume = MF_read("settings","settings","music")
				slider("music",x,y,8,{1,2},{3,2},"SettingsButton",0,100,tonumber(mvolume))
				
				y = y + tilesize
				
				writetext("sound volume:",0,x - tilesize * 6,y,name,false,2)
				local svolume = MF_read("settings","settings","sound")
				slider("sound",x,y,8,{1,2},{3,2},"SettingsButton",0,100,tonumber(svolume))
				
				y = y + tilesize
				
				writetext("input delay:",0,x - tilesize * 6,y,name,false,2)
				local delay = MF_read("settings","settings","delay")
				slider("delay",x,y,8,{1,2},{3,2},"SettingsButton",7,20,tonumber(delay))
				
				x = roomsize * tilesize * 0.5
				y = y + tilesize * 2
				
				createbutton("controls",x,y,2,16,1,"controls",name,3,2,"SettingsButton",disable)
				
				y = y + tilesize
				
				local fullscreen = MF_read("settings","settings","fullscreen")
				local c = gettoggle(fullscreen)
				createbutton("fullscreen",x,y,2,16,1,"toggle fullscreen",name,c[1],c[2],"SettingsButton")
				
				y = y + tilesize
				
				local grid = MF_read("settings","settings","grid")
				c = gettoggle(grid)
				createbutton("grid",x,y,2,16,1,"toggle grid",name,c[1],c[2],"SettingsButton")
				
				y = y + tilesize
				
				createbutton("return",x,y,2,16,1,"return",name,3,2,"SettingsButton")
			end,
		leave = 
			function(parent,name)
				MF_delete("SettingsButton")
			end,
		submenu_leave =
			function(parent,name)
				MF_visible("SettingsButton",0)
			end,
		submenu_return =
			function(parent,name)
				MF_visible("SettingsButton",1)
			end,
	},
	world =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 1.5
				writetext("select the world you want to edit:",0,x,y,name,true,1)
			end,
		leave = 
			function(parent,name)
				MF_delete("WorldChoice")
			end,
		submenu_leave =
			function(parent,name)
				MF_visible("WorldChoice",0)
			end,
		submenu_return =
			function(parent,name)
				MF_visible("WorldChoice",1)
			end,
	},
	level =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 0.5
				writetext("select the level you want to edit:",0,x,y,name,true,1)
				
				x = x * 0.5
				y = y + tilesize * 2
				
				createbutton("newlevel",x,y,2,10,1,"create a new level",name,3,2,"LevelButton")
				
				createbutton("themes",x,y + tilesize,2,10,1,"edit themes",name,3,2,"LevelButton")
				
				createbutton("return",x,y + tilesize * 2,2,10,1,"return to world list",name,3,2,"LevelButton")
				
				x = x + roomsize * tilesize * 0.5
				
				createbutton("deflevel",x,y,2,10,1,"set default level",name,3,2,"LevelButton")
				
				createbutton("startlevel",x,y + tilesize,2,10,1,"set first level",name,3,2,"LevelButton")
				
				MF_visible("LevelButton",1)
				
				editor.values[STATE] = 0
			end,
		leave = 
			function(parent,name)
				MF_delete("LevelButton")
				MF_letterclear("leveltext")
				MF_letterclear("nametext")
			end,
		submenu_leave =
			function(parent,name)
				MF_visible("LevelButton",0)
				MF_letterclear("nametext")
			end,
		submenu_return =
			function(parent,name)
				MF_visible("LevelButton",1)
			end,
	},
	name =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 1.5
				writetext("enter the name:",0,x,y,name,true)
			end,
		leave = 
			function(parent,name)
				MF_delete("LetterButton")
				MF_letterclear("nametext")
			end,
	},
	editor =
	{
		enter = 
			function(parent,name)
				local xo = tilesize * 0.5
				local yo = tilesize * 0.5
				local levelname = editor.strings[LEVELNAME]
				writetext(levelname,0,xo,yo,"editorname",false)
				
				local x = tilesize * roomsize * 0.5 + tilesize * 0.5
				local y = tilesize * 0.5
				
				createbutton("save",x,y,2,3,1,"save",name,3,2)
				
				x = x + tilesize * 2
				
				createbutton("l1",x,y,2,1,1,"1",name,3,2)
				
				x = x + tilesize
				
				createbutton("l2",x,y,2,1,1,"2",name,3,2)
				
				x = x + tilesize
				
				createbutton("l3",x,y,2,1,1,"3",name,3,2)
				
				x = x + tilesize * 2.5
				
				createbutton("objects",x,y,2,4,1,"objects",name,3,2)
				
				x = x + tilesize * 2.5
				
				createbutton("menu",x,y,2,1,1,"m",name,3,2)
				
				x = tilesize * 2.5
				y = tilesize * roomsize - tilesize * 0.5
				
				createbutton("addlevel",x,y,2,5,1,"add level",name,3,2)
				
				x = x + tilesize * 5.5
				
				createbutton("selector",x,y,2,6,1,"set selector",name,3,2)
				
				x = x + tilesize * 5
				
				createbutton("addpath",x,y,2,4,1,"add path",name,3,2)
				
				x = x + tilesize * 4
				
				createbutton("setpath",x,y,2,4,1,"set path",name,3,2)
				
				editor.values[STATE] = 0
			end,
		leave = 
			function(parent,name)
				MF_delete("EditorButton")
			end,
		submenu_leave = 
			function(parent,name)
				MF_visible("EditorButton",0)
			end,
		submenu_return = 
			function(parent,name)
				MF_visible("EditorButton",1)
			end,
	},
	editormenu =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 1.5
				
				y = y + tilesize * 1.5
				
				createbutton("closemenu",x,y,2,16,1,"close menu",name,3,2,"EditorMenuButton")
				
				y = y + tilesize
				
				createbutton("return",x,y,2,16,1,"return to level list",name,3,2,"EditorMenuButton")
				
				y = y + tilesize
				
				createbutton("rename",x,y,2,16,1,"rename level",name,3,2,"EditorMenuButton")
				
				y = y + tilesize
				
				createbutton("theme",x,y,2,16,1,"change level theme",name,3,2,"EditorMenuButton")
				
				y = y + tilesize
				
				createbutton("palette",x,y,2,16,1,"change level palette",name,3,2,"EditorMenuButton")
				
				y = y + tilesize
				
				createbutton("objectsetup",x,y,2,16,1,"object settings",name,3,2,"EditorMenuButton")
				
				y = y + tilesize
				
				createbutton("mapsetup",x,y,2,16,1,"map-related settings",name,3,2,"EditorMenuButton")
				
				y = y + tilesize * 2
				
				createbutton("delete",x,y,2,16,1,"delete level",name,3,2,"EditorMenuButton")
			end,
		leave = 
			function(parent,name)
				MF_delete("EditorMenuButton")
			end,
		submenu_leave =
			function(parent,name)
				MF_visible("EditorMenuButton",0)
			end,
		submenu_return =
			function(parent,name)
				MF_visible("EditorMenuButton",1)
				local x = tilesize * 0.5
				local y = tilesize * 0.5

				if (parent == "name") then
					MF_letterclear("editorname")
					writetext(editor.strings[LEVELNAME],0,x,y,name .. "name",false)
					MF_letterhide("editorname",0)
					--writetext(editor.strings[5],renamebuttonid,0,0,name,true)
				end
			end,
	},
	palette =
	{
		enter =
			function(parent,name)
				local world = generaldata.strings[WORLD]
				local rootpals = MF_filelist("Data/Palettes/","*.png")
				local pals = MF_filelist("Data/Worlds/" .. world .. "/Palettes/","*.png")
				
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 2
				
				writetext("select the palette you want to use:",0,x,y,name,true)
				
				x = x * 0.5
				
				y = y + tilesize
				
				createbutton("return",x,y,2,8,1,"return",name,3,2,"PaletteButton")
				
				if (#rootpals > 0) then
					for i,pal in ipairs(rootpals) do
						y = y + tilesize
						createbutton(pal,x,y,2,8,1,string.sub(pal, 1, string.len(pal) - 4),name,3,2,"RootPaletteButton")
					end
				end
				
				if (#pals > 0) then
					for i,pal in ipairs(pals) do
						y = y + tilesize
						createbutton(pal,x,y,2,8,1,string.sub(pal, 1, string.len(pal) - 4),name,3,2,"PaletteButton")
					end
				end
			end,
		leave = 
			function(parent,name)
				MF_delete("PaletteButton")
				MF_delete("RootPaletteButton")
			end,
	},
	mapsetup =
	{
		enter =
			function(parent,name)			
				local x = roomsize * tilesize * 0.5
				local leftx = tilesize * 2
				local y = tilesize * 2
				
				writetext("what is this level?",0,x,y,name,true)
				
				y = y + tilesize
				
				createbutton("islevel",roomsize * tilesize * 0.25,y,2,8,1,"level",name,3,2,"MapSetupButton")
				createbutton("ismap",roomsize * tilesize * 0.75,y,2,8,1,"map",name,3,2,"MapSetupButton")
				
				local leveltype = editor.values[LEVELTYPE] + 1
				makeselection({"islevel","ismap"},leveltype)
				
				y = y + tilesize
				
				writetext("levels needed for clear:",0,x,y,name,true)
				
				y = y + tilesize
				
				writetext("(zero -> unclearable)",0,x,y,name,true)
				
				y = y + tilesize
				
				createbutton("y--",x - tilesize * 2,y,2,1,1,"<<",name,3,2,"MapSetupButton")
				createbutton("y-",x - tilesize * 1,y,2,1,1,"<",name,3,2,"MapSetupButton")
				createbutton("y+",x + tilesize * 1,y,2,1,1,">",name,3,2,"MapSetupButton")
				createbutton("y++",x + tilesize * 2,y,2,1,1,">>",name,3,2,"MapSetupButton")
				
				local symbolid = MF_specialcreate("Editor_levelnum")
				local symbol = mmf.newObject(symbolid)
				symbol.values[TYPE] = editor.values[UNLOCKCOUNT]
				symbol.x = x
				symbol.y = y
				symbol.layer = 3
				
				y = y + tilesize * 2
				
				createbutton("seticons",x,y,2,16,1,"map icon setup",name,3,2,"MapSetupButton")
				
				y = y + tilesize * 2
				
				createbutton("return",x,y,2,8,1,"return",name,3,2,"MapSetupButton")
			end,
		leave = 
			function(parent,name)
				MF_delete("MapSetupButton")
			end,
		submenu_leave =
			function(parent,name)
				MF_visible("MapSetupButton",0)
			end,
		submenu_return =
			function(parent,name)
				MF_visible("MapSetupButton",1)
			end,
	},
	addlevel =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local leftx = tilesize * 2
				local y = tilesize * 1.5
				writetext("which level this leads to:",0,x,y,name,true)
				
				y = y + tilesize
				
				local unitid = editor.values[EDITTARGET]
				local unit = mmf.newObject(unitid)

				createbutton("changelevel",x,y,2,16,1,unit.strings[LEVELNAME],name,3,2,"AddLevel")
				
				y = y + tilesize * 3
				
				writetext("icon colour:",0,leftx,y,name,false)
				
				y = y + tilesize * 3
				
				writetext("initial state:",0,leftx - tilesize * 1.5,y,name,false)
				createbutton("s1",leftx + tilesize * 6,y,2,3.5,1,"hidden",name,3,2,"AddLevel")
				createbutton("s2",leftx + tilesize * 9.5,y,2,3.5,1,"normal",name,3,2,"AddLevel")
				createbutton("s3",leftx + tilesize * 13,y,2,3.5,1,"opened",name,3,2,"AddLevel")
				
				makeselection({"s1","s2","s3"},unit.values[COMPLETED] + 1)
				
				y = y + tilesize * 1
				
				writetext("symbol style:",0,leftx - tilesize * 1.5,y,name,false)
				createbutton("l1",leftx + tilesize * 5.5,y,2,2.5,1,"none",name,3,2,"AddLevel")
				createbutton("l2",leftx + tilesize * 8.6,y,2,3.5,1,"numbers",name,3,2,"AddLevel")
				createbutton("l3",leftx + tilesize * 11.6,y,2,2.5,1,"text",name,3,2,"AddLevel")
				createbutton("l4",leftx + tilesize * 14.1,y,2,2.5,1,"dots",name,3,2,"AddLevel")
				createbutton("l5",leftx + tilesize * 16.4,y,2,2,1,"...",name,3,2,"AddLevel")
				
				local lselect = unit.values[VISUALSTYLE]
				if (lselect == -2) then
					lselect = -1
				elseif (lselect == -1) then
					lselect = 3
				end
				
				makeselection({"l1","l2","l3","l4","l5"},lselect + 2)
				
				y = y + tilesize * 1
				
				writetext("symbol:",0,leftx - tilesize * 1.5,y,name,false)
				createbutton("y--",leftx + tilesize * 5,y,2,1,1,"<<",name,3,2,"AddLevel")
				createbutton("y-",leftx + tilesize * 6,y,2,1,1,"<",name,3,2,"AddLevel")
				createbutton("y+",leftx + tilesize * 9,y,2,1,1,">",name,3,2,"AddLevel")
				createbutton("y++",leftx + tilesize * 10,y,2,1,1,">>",name,3,2,"AddLevel")
				
				local symbolid = MF_specialcreate("Editor_levelnum")
				local symbol = mmf.newObject(symbolid)
				symbol.x = leftx + tilesize * 7.5
				symbol.y = y
				symbol.layer = 3
				
				y = y + tilesize * 1
				
				createbutton("return",x,y,2,16,1,"return",name,3,2,"AddLevel")
			end,
		submenu_leave = 
			function(parent,name)
				MF_visible("AddLevel",0)
			end,
		submenu_return = 
			function(parent,name)
				MF_visible("AddLevel",1)
			end,
		leave = 
			function(parent,name)
				MF_delete("AddLevel")
			end,
	},
	levelselect =
	{
		leave = 
			function(parent,name)
				MF_delete("LevelButton")
				MF_letterclear("leveltext")
				
				local unitid = editor.values[EDITTARGET]
				local unit = mmf.newObject(unitid)
				updatebuttontext("changelevel",unit.strings[LEVELNAME],parent)
			end,
	},
	spriteselect =
	{
		leave = 
			function(parent,name)
				MF_delete("SpriteButton")
				MF_letterclear("leveltext")
			end,
	},
	iconselect =
	{
		submenu_leave = 
			function(parent,name)
				MF_visible("IconButton",0)
			end,
		submenu_return = 
			function(parent,name)
				MF_visible("IconButton",1)
			end,
		enter =
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 1.5
				
				createbutton("return",x,y,2,16,1,"return",name,3,2,"IconButton")
			end,
		leave = 
			function(parent,name)
				MF_delete("IconButton")
			end,
	},
	icons =
	{
		enter =
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 1.5
				
				createbutton("return",x,y,2,16,1,"return",name,3,2,"IconButton")
			end,
		leave = 
			function(parent,name)
				MF_delete("IconButton")
			end,
	},
	deleteconfirm =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = roomsize * tilesize * 0.5 - tilesize * 3
				
				writetext("really remove this level?",0,x,y,name,true)
				
				y = y + tilesize * 2
				
				createbutton("yes",x,y,2,16,1,"yes",name,3,2,"DeleteConfirm")
				
				y = y + tilesize * 2
				
				createbutton("no",x,y,2,16,1,"no",name,3,2,"DeleteConfirm")
			end,
		leave = 
			function(parent,name)
				MF_delete("DeleteConfirm")
			end,
	},
	setpath =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 2.5
				
				createbutton("return",x,y,2,16,1,"return",name,3,2,"PathButton")
				
				y = y + tilesize * 1
				
				x = roomsize * tilesize * 0.25
				
				createbutton("hidden",x,y,2,8,1,"hidden",name,3,2,"PathButton")
				
				x = roomsize * tilesize * 0.75
				
				createbutton("visible",x,y,2,8,1,"visible",name,3,2,"PathButton")
				
				makeselection({"hidden","visible"},editor.values[PATHSTYLE] + 1)
				
				x = roomsize * tilesize * 0.5
				y = y + tilesize * 1
				
				writetext("is this path locked?",0,x,y,name,true)
				
				y = y + tilesize * 1
				
				x = roomsize * tilesize * 0.2
				
				createbutton("s1",x,y,2,6,1,"nope",name,3,2,"PathButton")
				
				x = roomsize * tilesize * 0.5
				
				createbutton("s2",x,y,2,6,1,"level clears",name,3,2,"PathButton")
				
				x = roomsize * tilesize * 0.8
				
				createbutton("s3",x,y,2,6,1,"map clears",name,3,2,"PathButton")
				
				makeselection({"s1","s2","s3"},editor.values[PATHGATE] + 1)
				
				x = roomsize * tilesize * 0.5
				y = y + tilesize * 1
				
				local symbolid = MF_specialcreate("Editor_levelnum")
				local symbol = mmf.newObject(symbolid)
				symbol.x = x
				symbol.y = y
				symbol.layer = 3
				
				createbutton("y--",x - tilesize * 2,y,2,1,1,"<<",name,3,2,"PathButton")
				createbutton("y-",x - tilesize * 1,y,2,1,1,"<",name,3,2,"PathButton")
				createbutton("y+",x + tilesize * 1,y,2,1,1,">",name,3,2,"PathButton")
				createbutton("y++",x + tilesize * 2,y,2,1,1,">>",name,3,2,"PathButton")
			end,
		leave = 
			function(parent,name)
				MF_delete("PathButton")
			end,
	},
	objectsetup =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 1.5
				
				createbutton("return",x,y,2,16,1,"return",name,3,2,"ObjectButton")
				
				if (editor.values[OBJECTSETUPTYPE] == 0) then
					y = y + tilesize * 2
				elseif (editor.values[OBJECTSETUPTYPE] == 1) then
					y = y + tilesize
					createbutton("palette",x,y,2,16,1,"change palette",name,3,2,"ObjectButton")
					y = y + tilesize
				end
				
				writetext("select the object you wish to edit:",0,x,y,name,true)
			end,
		leave = 
			function(parent,name)
				MF_delete("ObjectButton")
				MF_delete("ChangedTile")
			end,
		submenu_leave = 
			function(parent,name)
				MF_visible("ObjectButton",0)
				
				if (name ~= "palette") then
					MF_delete("ChangedTile")
				else
					MF_visible("ChangedTile",0)
				end
			end,
		submenu_return = 
			function(parent,name)
				MF_visible("ObjectButton",1)
				MF_visible("ChangedTile",1)
			end,
	},
	objectedit =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 1.5
				
				createbutton("return",x,y,2,16,1,"return",name,3,2,"ObjectEditButton")
				
				y = y + tilesize * 2
				
				local unitid = editor.values[EDITTARGET]
				local unit = mmf.newObject(unitid)
				
				local currname = unit.strings[UNITNAME]
				local realname = unit.className
				local unittype = unit.strings[UNITTYPE]
				
				writetext(currname .. " (" .. realname .. ") - " .. unittype,0,x,y,"objectinfo",true)
				
				x = roomsize * tilesize * 0.65
				y = y + tilesize * 1
				
				createbutton("sprite",x,y,2,12,1,"change sprite",name,3,2,"ObjectEditButton")
				
				y = y + tilesize * 1
				
				createbutton("name",x,y,2,12,1,"change name",name,3,2,"ObjectEditButton")
				
				y = y + tilesize * 1
				
				createbutton("type",x,y,2,12,1,"change type",name,3,2,"ObjectEditButton")
				
				y = y + tilesize * 1
				
				writetext("change colour:",0,x,y,name,true)
				
				y = y + tilesize * 1
				
				createbutton("colour",x - tilesize * 3.5,y,2,7,1,"base colour",name,3,2,"ObjectEditButton")
				createbutton("acolour",x + tilesize * 3.5,y,2,7,1,"active colour",name,3,2,"ObjectEditButton")
				
				y = y + tilesize * 1
				
				writetext("animation style:",0,x,y,name,true)
				
				y = y + tilesize * 1
				
				local w = 4.5
				
				local bw = w * tilesize
				local bh = tilesize
				
				local ox = x - bw
				
				createbutton("a1",ox,y,2,w,1,"none",name,3,2,"ObjectEditButton")
				createbutton("a2",ox + bw,y,2,w,1,"dirs",name,3,2,"ObjectEditButton")
				createbutton("a3",ox + bw * 2,y,2,w,1,"anim",name,3,2,"ObjectEditButton")
				createbutton("a4",ox,y + bh,2,w,1,"anim-dirs",name,3,2,"ObjectEditButton")
				createbutton("a5",ox + bw,y + bh,2,w,1,"character",name,3,2,"ObjectEditButton")
				createbutton("a6",ox + bw * 2,y + bh,2,w,1,"tiled",name,3,2,"ObjectEditButton")
				
				local aselect = unit.values[TILING]
				if (unit.values[TILING] == 4) then
					aselect = 1
				elseif (unit.values[TILING] == 3) then
					aselect = 2
				elseif (unit.values[TILING] == 2) then
					aselect = 3
				elseif (unit.values[TILING] == 1) then
					aselect = 4
				end
				
				makeselection({"a1","a2","a3","a4","a5","a6"},aselect + 2)
				
				y = y + tilesize * 2
				
				writetext("text type:",0,x,y,name,true)
				
				y = y + tilesize * 1
				
				createbutton("w1",ox,y,2,w,1,"baba",name,3,2,"ObjectEditButton")
				createbutton("w2",ox + bw,y,2,w,1,"is",name,3,2,"ObjectEditButton")
				createbutton("w3",ox + bw * 2,y,2,w,1,"you",name,3,2,"ObjectEditButton")
				
				makeselection({"w1","w2","w3"},unit.values[TYPE] + 1)
				
				y = y + tilesize * 1
				
				writetext("manual text type selection:",0,x,y,name,true)
				
				y = y + tilesize * 1
				
				createbutton("-",x - tilesize * 1,y,2,1,1,"<",name,3,2,"ObjectEditButton")
				createbutton("+",x + tilesize * 1,y,2,1,1,">",name,3,2,"ObjectEditButton")
				
				local symbolid = MF_specialcreate("Editor_levelnum")
				local symbol = mmf.newObject(symbolid)
				symbol.x = x
				symbol.y = y
				symbol.layer = 3
				
				symbol.values[TYPE] = unit.values[TYPE]
				
				y = y + tilesize * 2
				
				createbutton("reset",x,y,2,12,1,"reset all values",name,3,2,"ObjectEditButton")
			end,
		leave = 
			function(parent,name)
				MF_delete("ObjectEditButton")
				MF_letterclear("objectinfo",0)
			end,
		submenu_leave = 
			function(parent,name)
				MF_visible("ObjectEditButton",0)
				MF_letterclear("objectinfo",0)
			end,
		submenu_return = 
			function(parent,name)
				MF_visible("ObjectEditButton",1)
				
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 3.5
				
				local unitid = editor.values[EDITTARGET]
				local unit = mmf.newObject(unitid)
				
				local currname = unit.strings[UNITNAME]
				local realname = unit.className
				local unittype = unit.strings[UNITTYPE]
				
				writetext(currname .. " (" .. realname .. ") - " .. unittype,0,x,y,"objectinfo",true)
			end,
	},
	themes =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 1.5
				writetext("select the theme you want to edit:",0,x,y,name,true,1)
				
				y = y + tilesize
				
				createbutton("return",x,y,2,16,1,"return",name,3,2,"ThemeChoice")
			end,
		leave = 
			function(parent,name)
				MF_delete("ThemeChoice")
			end,
		submenu_leave =
			function(parent,name)
				MF_visible("ThemeChoice",0)
			end,
		submenu_return =
			function(parent,name)
				MF_visible("ThemeChoice",1)
			end,
	},
	themeselect =
	{
		enter = 
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 1.5
				writetext("select the theme you want to use:",0,x,y,name,true,2)

				y = y + tilesize
				
				createbutton("return",x,y,2,16,1,"return to level setup",name,3,2,"ThemeButton")
			end,
		leave = 
			function(parent,name)
				MF_delete("ThemeButton")
				MF_delete("ThemeChoice")
				MF_letterclear("themes")
			end,
	},
	object_colour =
	{
		enter =
			function(parent,name)
				local x = roomsize * tilesize * 0.5
				local y = tilesize * 2
				
				writetext("what colour should this object use?",0,x,y,name,true)
				
				y = y + tilesize
				
				createbutton("return",x,y,2,8,1,"return",name,3,2,"ColourButton")
				
				y = y + tilesize
			end,
		leave = 
			function(parent,name)
				MF_delete("ColourButton")
			end,
	},
	pause =
	{
		enter = 
			function(parent,name)
				local x = tilesize * 5
				local y = tilesize * 2
				
				createbutton("resume",x,y,2,8,1,"resume",name,1,3,"PauseMenu")
				
				y = y + tilesize
				
				createbutton("restart",x,y,2,8,1,"restart",name,1,3,"PauseMenu")
				
				y = y + tilesize
				
				createbutton("settings",x,y,2,8,1,"settings",name,1,3,"PauseMenu")
				
				y = y + tilesize
				
				createbutton("return",x,y,2,8,1,"return to map",name,1,3,"PauseMenu")
				
				x = tilesize * 9
				y = tilesize * 1
				
				writerules(parent,name,x,y)
			end,
		leave = 
			function(parent,name)
				MF_delete("PauseMenu")
			end,
		submenu_leave =
			function(parent,name)
				MF_visible("PauseMenu",0)
			end,
		submenu_return =
			function(parent,name)
				MF_visible("PauseMenu",1)
			end,
	},
}